#include <stdio.h>
#include <string.h>
#include "mem.h"
#include "gif.h"

static FILE          * f;
static short int       b, bpc, shift, NumColor;
static unsigned char   Buf[256];
static unsigned char   Interlaced,num;
static TLong           Table[8196];
static TLong           LongSt;
static unsigned char   Pixel[4095];
static unsigned short  Mask[13]={0,1,3,7,0x0F,0x1F,0x3F,0x7F,0xFF,0x01FF,0x03FF,0x07FF,0x0FFF};
static unsigned char * PBmp;

unsigned short int GetCode()
{
    unsigned char BitPerCode;
    short int     code;
    int           C0, C1, C2;

    BitPerCode=bpc+shift;
    C0=Buf[b-1];
    if (BitPerCode<8)
    {
        code=(C0 >> shift) & Mask[bpc];
        shift=BitPerCode;
    } else {
        BitPerCode-=8;
        if (b==num)
        {
            num=Buf[num];
            fread(&Buf, (short)(num+1), 1, f);
            b=0;
        }
        C1=Buf[b++];
        if (BitPerCode<8)
        {
            code=(((C1 << 8)+C0) >> shift) & Mask[bpc];
            shift=BitPerCode;
        } else
        {
            if (b==num)
            {
                num=Buf[num];
                fread(&Buf, (short)(num+1), 1, f);
                b=0;
            }
            C2=Buf[b++];
            code=(((C2 << 16)+(C1 << 8)+C0) >> shift) & Mask[bpc];
            shift=BitPerCode-8;
        };
    };
    return code;
}

void OutPixels(short int cur_code)
{
  short int NumPix=0;
  int i;

  while (cur_code>NumColor+1)
  {
      Pixel[NumPix]=Table[cur_code].b.b2;
      cur_code=Table[cur_code].w.w0;
      NumPix++;
  }
  Pixel[NumPix]=cur_code & 0xFF;
  LongSt.b.b2=cur_code & 0xFF;
  for (i=NumPix; i>=0; i--) *PBmp++=Pixel[i];
}

int LoadGif(char *filename, IMAGE *PImage)
{
    struct TFileHeader {
        unsigned char Id[6];
        short int     Xres, Yres;
        unsigned char Flags, BackColor, Res; } fh;
    struct TImageHeader {
        short int     X0, Y0, Xres, Yres;
        unsigned char Flags, BitPerPixel; } ih;
    unsigned char   BlockID;
    short int       Max, ByteCount, code;
    int             DeltaY, DeltaMemAddr;

    if(!(f = fopen(filename, "rb"))) return 1;
    if (fread(&fh, 13, 1, f) != 1) return 1;
    if ((fh.Id[0] != 'G') || (fh.Id[1] != 'I') || (fh.Id[2] != 'F')) return 2;
    if ((fh.Id[3] != '8') || ((fh.Id[4] != '7') && (fh.Id[4] != '9')) || (fh.Id[5] != 'a')) return 2;
    if (fh.Flags & 0x80)
    {
        NumColor = 1 << ((fh.Flags & 0x07)+1);
        if (fread(&(PImage->Pal), 3, NumColor, f) != NumColor) return 3;
    }
NextBlock:
    if (fread(&BlockID, 1, 1, f) != 1) return 4;
    if (BlockID==0x21)
    {
        ByteCount=1;
        while (ByteCount != 0)
        {
            if (fread(&Buf, ByteCount+1, 1, f) != 1) return 4;
            ByteCount=Buf[ByteCount];
        }
        goto NextBlock;
    }
    if (BlockID!=0x2C) return 5;
    if (fread(&ih, 10, 1, f) != 1) return 6;
    if (ih.Flags & 0x80)
    {
        NumColor = 1 << ((fh.Flags & 0x07)+1);
        if (fread(&(PImage->Pal), 3, NumColor, f) != NumColor) return 7;
    }
    NumColor = 1 << ih.BitPerPixel;
    Interlaced = ih.Flags & 0x40;
    PImage->Xres=ih.Xres;
    PImage->Yres=ih.Yres;
    PImage->NumPixel=(PImage->Xres) * (PImage->Yres);
    PImage->BitPerPixel=ih.BitPerPixel;

    GetMemForImage(PImage);
    PBmp=PImage->PBitmap.p.p0;
    if (PBmp==NULL) return 13;
    if (Interlaced) DeltaY=8; else DeltaY=1;
    DeltaMemAddr=(PImage->Xres)*DeltaY;
    if (fread(&num, 1, 1, f) != 1) return 8;
    if (fread(&Buf, (short)(num+1), 1, f) != 1) return 9;
    b=1;
    shift=0;
    bpc=PImage->BitPerPixel+1;
    code=GetCode();
M1:
    Max=NumColor+2;
    bpc=PImage->BitPerPixel+1;
    code=GetCode();
    OutPixels(code);
M2:
    LongSt.w.w0=code;
    code=GetCode();
    switch(code-NumColor)
    {
        case 0: goto M1;
        case 1:
        {
            fclose(f);
            return 0;
        }
    }
    if (code<Max)
    {
        OutPixels(code);
        Table[Max]=LongSt;
        Max++;
        if ((bpc<12) && (Max==(1 << bpc))) bpc++;
    } else
    {
        Table[Max]=LongSt;
        Max++;
        if ((bpc<12) && (Max==(1 << bpc))) bpc++;
        OutPixels(code);
    }
    goto M2;
}
