/*********************************************************
 *      HIEND-2D.C - Shows 2D texture in 640x480x256.    *
 * ---> advanced set of 254 interpolating functions <--- *
 *                                                       *
 *   (c) 1997-1999 Stepin Maxim       (stepin@mail.ru)   *
 *********************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <i86.h>
#include <string.h>
#include "maindefs.h"
#include "sinus.h"
#include "mem.h"
#include "bmp.h"
#include "gif.h"

#define BUF_X_RES       640
#define BUF_Y_RES       480
#define BUF_SIZE        640*480

static struct rmregs {
    long  EDI, ESI, EBP, Res, EBX, EDX, ECX, EAX;
    short flags, ES, DS, FS, GS, IP, CS, SP, SS; } RmRegs;

struct TPoint { TLong X, Y; };

static int         As=0;
static int         Ms=128;
static TLong       Xs={0};
static TLong       Ys={0};
static short       QFlag=3;
static short       MFlag=0;
static short int   ScrPal[256][3];
static int         Corn[4][2]={{-64,-64},{63,-64},{63,63},{-64,63}};

struct vesainfo {
    char                 Signature[4];
    unsigned char        VersionLo;
    unsigned char        VersionHi;
    char far             *PInfoOEM;
    unsigned long        Capabilities;
    unsigned short far   *PModeTable;
    unsigned short       TotalMemory;             // VESA 1.2
    unsigned short       RevVersion;              // VBE 2.0
    char far             *POEMName;               // VBE 2.0
    char far             *POEMProductName;        // VBE 2.0
    char far             *POEMRevVersion;         // VBE 2.0
    char                 Reserved[222];
    char                 OEMData[256];            // VBE 2.0
};

struct vesamodeinfo {
    unsigned short       ModeAttr;
    unsigned char        WinAAttr;
    unsigned char        WinBAttr;
    unsigned short       WinGranularity;
    unsigned short       WinSize;
    unsigned short       WinASegment;
    unsigned short       WinBSegment;
    void far             *WinFuncPtr;
    unsigned short       BytesPerScanLine;
    unsigned short       XResolution;             // VESA 1.2
    unsigned short       YResolution;             // VESA 1.2
    unsigned char        XCharSize;               // VESA 1.2
    unsigned char        YCharSize;               // VESA 1.2
    unsigned char        NumPlanes;               // VESA 1.2
    unsigned char        BitsPerPixel;            // VESA 1.2
    unsigned char        NimBanks;                // VESA 1.2
    unsigned char        MemoryModel;             // VESA 1.2
    unsigned char        BankSize;                // VESA 1.2
    unsigned char        NumPages;                // VESA 1.2
    unsigned char        Reserved1;               // VESA 1.2
    unsigned char        RedSize;                 // VESA 1.2
    unsigned char        RedField;                // VESA 1.2
    unsigned char        GreenSize;               // VESA 1.2
    unsigned char        GreenField;              // VESA 1.2
    unsigned char        BlueSize;                // VESA 1.2
    unsigned char        BlueField;               // VESA 1.2
    unsigned char        ResSize;                 // VESA 1.2
    unsigned char        ResField;                // VESA 1.2
    unsigned char        DACInfo;                 // VESA 1.2
    unsigned char far    *PVideoBuffer;           // VBE 2.0
    unsigned char far    *BackScrOffset;          // VBE 2.0
    unsigned short       BackScrSize;             // VBE 2.0
    unsigned char        Reserved2[206];          // VBE 2.0
};

extern void NormalLine(int Count, void *PTexture, void *PBuffer, int Xt, int Yt, int dXt, int dYt);
extern void SmoothLine(int Count, void *PTexture, void *PBuffer, int Xt, int Yt, int dXt, int dYt);
extern void PerfectLine(int Count, void *PTexture, void *PBuffer, int Xt, int Yt, int dXt, int dYt);

int InitGraph(short Mode, int *Step)
{
    union REGS regs;
    struct SREGS sregs;
    unsigned short selector, segment;
    struct vesainfo far *PVesaInfo;
    struct vesamodeinfo far *PVesaModeInfo;

    memset(&regs, 0, sizeof(regs));
    regs.w.ax=0x0100;
    regs.w.bx=0x0020;
    int386(0x31, &regs, &regs);
    segment=regs.w.ax;
    selector=regs.w.dx;

    memset(&RmRegs, 0, sizeof(RmRegs));
    RmRegs.EAX=0x00004F00;
    RmRegs.ES=segment;
    RmRegs.EDI=0;
    segread(&sregs);
    memset(&regs, 0, sizeof(regs));
    regs.w.ax=0x0300;
    regs.h.bl=0x10;
    regs.h.bh=0;
    regs.w.cx=0;
    sregs.es=FP_SEG(&RmRegs);
    regs.x.edi=FP_OFF(&RmRegs);
    int386x(0x31, &regs, &regs, &sregs);
    if ((RmRegs.EAX & 0xFFFF) != 0x004F) return 1;
    PVesaInfo=(struct vesainfo *)(segment<<4);
    printf(" %4.4s", PVesaInfo->Signature);
    printf(" %i.%i is detected.\n", PVesaInfo->VersionHi, PVesaInfo->VersionLo);

    memset(&RmRegs, 0, sizeof(RmRegs));
    RmRegs.EAX=0x00004F01;
    RmRegs.ECX=Mode;
    RmRegs.ES=segment;
    RmRegs.EDI=0;
    segread(&sregs);
    memset(&regs, 0, sizeof(regs));
    regs.w.ax=0x0300;
    regs.h.bl=0x10;
    regs.h.bh=0;
    regs.w.cx=0;
    sregs.es=FP_SEG(&RmRegs);
    regs.x.edi=FP_OFF(&RmRegs);
    int386x(0x31, &regs, &regs, &sregs);
    if ((RmRegs.EAX & 0xFFFF) != 0x004F) return 2;
    PVesaModeInfo=(struct vesamodeinfo *)(segment<<4);
    if ((PVesaModeInfo->ModeAttr) & 0x01 == 0) return 3;
    if ((PVesaModeInfo->WinSize) != 64) return 4;
    *Step=(PVesaModeInfo->WinSize)/(PVesaModeInfo->WinGranularity);

    memset(&RmRegs, 0, sizeof(RmRegs));
    RmRegs.EAX=0x00004F02;
    RmRegs.EBX=Mode;
    segread(&sregs);
    memset(&regs, 0, sizeof(regs));
    regs.w.ax=0x0300;
    regs.h.bl=0x10;
    regs.h.bh=0;
    regs.w.cx=0;
    sregs.es=FP_SEG(&RmRegs);
    regs.x.edi=FP_OFF(&RmRegs);
    int386x(0x31, &regs, &regs, &sregs);
    if ((RmRegs.EAX & 0xFFFF) != 0x004F) return 5;

    memset(&regs, 0, sizeof(regs));
    regs.w.ax=0x0101;
    regs.w.dx=selector;
    int386(0x31, &regs, &regs);
    return 0;
}

void CloseGraph()
{
    _asm
    {
        mov  ax, 3
        int  10h
    };
}

void SetPalette()
{
    union REGS regs;
    struct SREGS sregs;
    unsigned short selector, segment, i;
    unsigned char *Palette;

    memset(&regs, 0, sizeof(regs));
    regs.w.ax=0x0100;
    regs.w.bx=0x0030;
    int386(0x31, &regs, &regs);
    segment=regs.w.ax;
    selector=regs.w.dx;
    Palette=(unsigned char *)(segment<<4);
    for (i=0; i<256; i++)
    {
        *Palette++=(unsigned char) ScrPal[i][0];
        *Palette++=(unsigned char) ScrPal[i][1];
        *Palette++=(unsigned char) ScrPal[i][2];
    }
    memset(&RmRegs, 0, sizeof(RmRegs));
    RmRegs.EAX=0x00001012;
    RmRegs.EBX=0;
    RmRegs.ECX=256;
    RmRegs.EDX=0;
    RmRegs.ES=segment;
    segread(&sregs);
    memset(&regs, 0, sizeof(regs));
    regs.w.ax=0x0300;
    regs.h.bl=0x10;
    regs.h.bh=0;
    regs.w.cx=0;
    sregs.es=FP_SEG(&RmRegs);
    regs.x.edi=FP_OFF(&RmRegs);
    int386x(0x31, &regs, &regs, &sregs);
    memset(&regs, 0, sizeof(regs));
    regs.w.ax=0x0101;
    regs.w.dx=selector;
    int386(0x31, &regs, &regs);
}

int InitMouse()
{
    union REGS regs;

    memset(&regs, 0, sizeof(regs));
    regs.w.ax=0x0000;
    int386(0x33, &regs, &regs);
    if (regs.w.ax != 0xFFFF) return (regs.w.ax+1);
    memset(&regs, 0, sizeof(regs));
    regs.w.ax=0x000B;
    int386(0x33, &regs, &regs);
    return 0;
}

int MouseButtons()
{
    union REGS regs;

    memset(&regs, 0, sizeof(regs));
    regs.w.ax=0x0003;
    int386(0x33, &regs, &regs);
    return regs.w.bx;
}

void WhereMouse(short int * DeltaX, short int * DeltaY)
{
    union REGS regs;

    memset(&regs, 0, sizeof(regs));
    regs.w.ax=0x000B;
    int386(0x33, &regs, &regs);
    *DeltaX=regs.w.cx;
    *DeltaY=regs.w.dx;
}

int MulDiv(int N1, int N2, int N3);
#pragma aux MulDiv = \
"imul ebx" \
"idiv ecx" \
parm [eax] [ebx] [ecx] \
modify [eax edx] \
value [eax];

void Rotate(TLong *X1, TLong *Y1, long int A)
{
    int Xtmp, Ytmp;

    Xtmp = (*X1).l.l0;
    Ytmp = (*Y1).l.l0;
    if (A)
    _asm
    {
        mov  esi, offset sinus
        mov  edi, A
        mov  eax, Xtmp
        imul dword ptr [esi+edi*4+0x0C00]
        mov  ebx, edx                   // ebx <-- Xs*Cos(F)
        mov  eax, Ytmp
        imul dword ptr [esi+edi*4+0x0C00]
        mov  ecx, edx                   // ecx <-- Ys*Cos(F)
        mov  eax, Ytmp
        imul dword ptr [esi+edi*4+0x0800]
        sub  ebx, edx                   // ebx <-- Xs*Cos(F)-Ys*Sin(F)
        mov  eax, Xtmp
        imul dword ptr [esi+edi*4+0x0800]
        add  ecx, edx                   // ecx <-- Ys*Cos(F)+Xs*Sin(F)
        shl  ebx, 1
        mov  Xtmp, ebx
        shl  ecx, 1
        mov  Ytmp, ecx
    };
    (*X1).l.l0=Xtmp;
    (*Y1).l.l0=Ytmp;
}

void SetVideoBank(int bank)
{
    union REGS regs;
    struct SREGS sregs;

    memset(&RmRegs, 0, sizeof(RmRegs));
    RmRegs.EAX=0x00004F05;
    RmRegs.EBX=0;
    RmRegs.EDX=bank;
    segread(&sregs);
    memset(&regs, 0, sizeof(regs));
    regs.w.ax=0x0300;
    regs.h.bl=0x10;
    regs.h.bh=0;
    regs.w.cx=0;
    sregs.es=FP_SEG(&RmRegs);
    regs.x.edi=FP_OFF(&RmRegs);
    int386x(0x31, &regs, &regs, &sregs);
}

void DrawInBuffer(unsigned char *PBuf, unsigned char *PImage)
{
    int                 i, j, X1, X2, Y1, Y2;
    TLong           Xl, Yl, Xr, Yr, Xl2, Yl2, Xr2, Yr2, dXl, dXr, MinY, MaxY;
    TLong           Xt, Yt, dXt, dYt, Xt2, Yt2, dXt2, dYt2;
    struct TPoint       Vert[4];
    short int           VertL, VertR;
    unsigned char     * PBufTmp;
    int                 count=BUF_SIZE/4;
    extern short int    Xerr, Yerr;
    extern char         Uerr, Werr;

    srand(239);
    _asm
    {
         cld
         mov  ecx, count
         mov  edi, PBuf
         xor  eax, eax
         rep  stosd
    };
    MinY.l.l0=1024*65536;
    MaxY.l.l0=-1024*65536;
    for (i=0; i<4; i++)
    {
        Xt.l.l0=(Corn[i][0]*65536/128)*Ms;
        Yt.l.l0=(Corn[i][1]*65536/128)*Ms;
        Rotate(&Xt, &Yt, As);
        Vert[i].X.l.l0=Xt.l.l0+Xs.l.l0+BUF_X_RES*32768;
        Vert[i].Y.l.l0=Yt.l.l0+Ys.l.l0+BUF_Y_RES*32768;
        if (Vert[i].Y.l.l0<MinY.l.l0) MinY.l.l0=Vert[i].Y.l.l0;
        if (Vert[i].Y.l.l0>MaxY.l.l0) MaxY.l.l0=Vert[i].Y.l.l0;
    }
    MinY.l.l0--;
    Y1=MinY.i.i1+1;
    MaxY.l.l0--;
    Y2=MaxY.i.i1+1;
    if ((Y1>=BUF_Y_RES) || (Y2<0) || (Y1>=Y2)) return;
    if (Y1<0) Y1=0;
    if (Y2>BUF_Y_RES) Y2=BUF_Y_RES;
    for (i=0; i<4; i++)
    {
        j=(i+1) & 3;
        if ((Vert[j].Y.l.l0<=Y1*65536) && (Vert[i].Y.l.l0>Y1*65536)) VertL=j;
        if ((Vert[i].Y.l.l0<=Y1*65536) && (Vert[j].Y.l.l0>Y1*65536)) VertR=i;
    }
    Xl2=Vert[VertL].X;
    Yl2=Vert[VertL].Y;
    Xr2=Vert[VertR].X;
    Yr2=Vert[VertR].Y;
    dXt2.l.l0=MulDiv(2*128, sinus[768-As], Ms*65536);     //cos(-As)
    dYt2.l.l0=MulDiv(2*128, sinus[512-As], Ms*65536);     //sin(-As)
    for (j=Y1; j<Y2; j++)
    {
        if ((j==Y1) || (j==Yl2.i.i1+1))
        {
            Xl=Xl2;
            Yl=Yl2;
            VertL=(VertL+3) & 3;
            Xl2=Vert[VertL].X;
            Yl2=Vert[VertL].Y;
            dXl.l.l0=MulDiv(Xl2.l.l0-Xl.l.l0, 65536, Yl2.l.l0-Yl.l.l0);
            Xl.l.l0+=MulDiv(Xl2.l.l0-Xl.l.l0, j*65536-Yl.l.l0, Yl2.l.l0-Yl.l.l0);
        }
        if ((j==Y1) || (j==Yr2.i.i1+1))
        {
            Xr=Xr2;
            Yr=Yr2;
            VertR=(VertR+1) & 3;
            Xr2=Vert[VertR].X;
            Yr2=Vert[VertR].Y;
            dXr.l.l0=MulDiv(Xr2.l.l0-Xr.l.l0, 65536, Yr2.l.l0-Yr.l.l0);
            Xr.l.l0+=MulDiv(Xr2.l.l0-Xr.l.l0, j*65536-Yr.l.l0, Yr2.l.l0-Yr.l.l0);
        }
        X1=(Xl.l.l0+65535)/65536;
        X2=(Xr.l.l0+65535)/65536;
        switch (VertL)
        {
            case 0: {
                Xt.l.l0=MulDiv(127*65536, Yl2.l.l0-j*65536, Yl2.l.l0-Yl.l.l0);
                Yt.l.l0=0;
                break; }
            case 1: {
                Xt.l.l0=127*65536;
                Yt.l.l0=MulDiv(127*65536, Yl2.l.l0-j*65536, Yl2.l.l0-Yl.l.l0);
                break; }
            case 2: {
                Xt.l.l0=MulDiv(127*65536, j*65536-Yl.l.l0, Yl2.l.l0-Yl.l.l0);
                Yt.l.l0=127*65536;
                break; }
            case 3: {
                Xt.l.l0=0;
                Yt.l.l0=MulDiv(127*65536, j*65536-Yl.l.l0, Yl2.l.l0-Yl.l.l0);
                break; }
        }
        switch (VertR)
        {
            case 0: {
                Xt2.l.l0=0;
                Yt2.l.l0=MulDiv(127*65536, Yr2.l.l0-j*65536, Yr2.l.l0-Yr.l.l0);
                break; }
            case 1: {
                Xt2.l.l0=MulDiv(127*65536, j*65536-Yr.l.l0, Yr2.l.l0-Yr.l.l0);
                Yt2.l.l0=0;
                break; }
            case 2: {
                Xt2.l.l0=127*65536;
                Yt2.l.l0=MulDiv(127*65536, j*65536-Yr.l.l0, Yr2.l.l0-Yr.l.l0);
                break; }
            case 3: {
                Xt2.l.l0=MulDiv(127*65536, Yr2.l.l0-j*65536, Yr2.l.l0-Yr.l.l0);
                Yt2.l.l0=127*65536;
                break; }
        }
        if (Xl.w.w0)
        {
            Xt.l.l0+=MulDiv(dXt2.l.l0, 0x10000-Xl.w.w0, 0x10000);
            Yt.l.l0+=MulDiv(dYt2.l.l0, 0x10000-Xl.w.w0, 0x10000);
        }
        if (Xr.w.w0)
        {
            Xt2.l.l0-=MulDiv(dXt2.l.l0, Xr.w.w0, 0x10000);
            Yt2.l.l0-=MulDiv(dYt2.l.l0, Xr.w.w0, 0x10000);
        }
        if (X1<0)
        {
            Xt.l.l0-=MulDiv(2*128*X1, sinus[768-As], Ms*65536);
            Yt.l.l0-=MulDiv(2*128*X1, sinus[512-As], Ms*65536);
            X1=0;
        };
        if (X2>BUF_X_RES)
        {
            Xt2.l.l0-=MulDiv(2*128*(X2-BUF_X_RES), sinus[768-As], Ms*65536);
            Yt2.l.l0-=MulDiv(2*128*(X2-BUF_X_RES), sinus[512-As], Ms*65536);
            X2=BUF_X_RES;
        };
        if (X1<X2)
        {
            dXt.l.l0=(Xt2.l.l0-Xt.l.l0)/(X2-X1);
            dYt.l.l0=(Yt2.l.l0-Yt.l.l0)/(X2-X1);
            PBufTmp=PBuf;
            PBufTmp+=(j*BUF_X_RES+X1);
            Xerr=rand();
            Yerr=rand();
            Uerr=rand() & 0xFF;
            Werr=rand() & 0xFF;
            switch(QFlag)
            {
                case 1:
                {
                    NormalLine(X2-X1, PImage, PBufTmp, Xt.l.l0, Yt.l.l0, dXt.l.l0, dYt.l.l0);
                    break;
                }
                case 2:
                {
                    SmoothLine(X2-X1, PImage, PBufTmp, Xt.l.l0, Yt.l.l0, dXt.l.l0, dYt.l.l0);
                    break;
                }
                case 3:
                {
                    PerfectLine(X2-X1, PImage, PBufTmp, Xt.l.l0, Yt.l.l0, dXt.l.l0, dYt.l.l0);
                    break;
                }
                case 4:
                {
                    if (Ms<180) NormalLine(X2-X1, PImage, PBufTmp, Xt.l.l0, Yt.l.l0, dXt.l.l0, dYt.l.l0);
                    else PerfectLine(X2-X1, PImage, PBufTmp, Xt.l.l0, Yt.l.l0, dXt.l.l0, dYt.l.l0);
                    break;
                }
            }
        }
        Xl.l.l0+=dXl.l.l0;
        Xr.l.l0+=dXr.l.l0;
    }

}

void BufferToScreen(unsigned char *PBuf, int Step)
{
    int bank=0;
    int count=BUF_SIZE/4;

    while (count>16384)
    {
        SetVideoBank(bank);
        _asm
        {
             cld
             mov  ecx, 16384
             mov  esi, PBuf
             mov  edi, 0x000A0000
             rep  movsd
        };
        PBuf+=65536;
        bank+=Step;
        count-=16384;
    }
    SetVideoBank(bank);
    _asm
    {
         cld
         mov  ecx, count
         mov  esi, PBuf
         mov  edi, 0x000A0000
         rep  movsd
    };
}

void MagnBuffer(unsigned char *PBuf) // only for 640x480
{
    TLong PBuf1, PBuf2;

    PBuf1.p.p0=PBuf;
    PBuf2.p.p0=PBuf;
    PBuf1.l.l0+=(210*640+280);
    PBuf2.l.l0+=(BUF_SIZE-80*60);
    _asm
    {
        cld
        mov  ecx, 60
        mov  esi, dword ptr PBuf1
        mov  edi, dword ptr PBuf2
      l01:
        push cx
        mov  cx, 20
        rep  movsd
        pop  cx
        add  esi, 560
        loop l01
    };
    PBuf1.p.p0=PBuf;
    PBuf2.p.p0=PBuf;
    PBuf1.l.l0+=(BUF_SIZE-80*60);
    _asm
    {
        cld
        mov  ecx, 60
        mov  esi, dword ptr PBuf1
        mov  edi, dword ptr PBuf2
      l01:
        push ecx
        mov  ecx, 80
      l02:
        mov  al, [esi]
        mov  ah, al
        shl  eax, 16
        mov  al, [esi]
        mov  ah, al
        mov  [edi], eax
        mov  [edi+4], eax
        mov  [edi+640], eax
        mov  [edi+644], eax
        mov  [edi+1280], eax
        mov  [edi+1284], eax
        mov  [edi+1920], eax
        mov  [edi+1924], eax
        mov  [edi+2560], eax
        mov  [edi+2564], eax
        mov  [edi+3200], eax
        mov  [edi+3204], eax
        mov  [edi+3840], eax
        mov  [edi+3844], eax
        mov  [edi+4480], eax
        mov  [edi+4484], eax
        inc  esi
        add  edi, 8
        loop l02
        pop  ecx
        add  edi, 4480
        loop l01
    };
}

void main(int argc, char * argv[])
{
    short int   Dx, Dy;
    int         Res, Step, i, Mb, T;
    char        ch;
    IMAGE       Image, Buf;
    char      * filename="TEXT01M.GIF";
    auto char OutStr[30];

    printf("Let's go\n");
    if (argc>1) filename=argv[1];
    Res=LoadGif(filename, &Image);
    if (Res) { printf("LoadGif ERROR %i in file '%s'\n", Res, filename); return; };
    printf("Resolution is %ix%i\n", Image.Xres, Image.Yres);
    if ((Image.Xres!=256) || (Image.Yres!=128))
    { printf("ERROR: Expected resolution is 256x128.\n"); return; };

    Buf.Xres=BUF_X_RES;
    Buf.Yres=BUF_Y_RES;
    Buf.NumPixel=BUF_SIZE;
    Buf.BitPerPixel=8;
    for (i=0; i<256; i++)
    {
        Buf.Pal[i].r=Image.Pal[i].r;
        Buf.Pal[i].g=Image.Pal[i].g;
        Buf.Pal[i].b=Image.Pal[i].b;
    }
    GetMemForImage(&Buf);
    if (Buf.PBitmap.p.p0==NULL) { printf("Buf.GetMem ERROR \n"); return; };

    Res=InitGraph(0x101, &Step);
    if (Res==5) CloseGraph;
    if (Res) { printf("InitGraph ERROR: %i\n", Res); return; }
    for (i=0; i<256; i++)
    {
        ScrPal[i][0]=Image.Pal[i].r/4;
        ScrPal[i][1]=Image.Pal[i].g/4;
        ScrPal[i][2]=Image.Pal[i].b/4;
    }
    SetPalette();

    strcpy(OutStr, "That's all folks");
    Res=InitMouse();
    if (Res) { strcpy(OutStr, "Mouse not installed !"); goto Fin; }

Start:
    Mb=MouseButtons();
    WhereMouse(&Dx, &Dy);
    if (kbhit())
    {
        ch=getch();
        switch (ch)
        {
            case  27: goto Fin;
            case '+': {
                if (Ms<16384)
                {
                    Xs.l.l0=MulDiv(Xs.l.l0, Ms+1, Ms);
                    Ys.l.l0=MulDiv(Ys.l.l0, Ms+1, Ms);
                    Ms++;
                }
                break;
            };
            case '-': {
                if (Ms>128)
                {
                    Xs.l.l0=MulDiv(Xs.l.l0, Ms-1, Ms);
                    Ys.l.l0=MulDiv(Ys.l.l0, Ms-1, Ms);
                    Ms--;
                }
                break;
            };
            case '*': {
                if (Ms<=8192)
                {
                    Xs.l.l0=2*Xs.l.l0;
                    Ys.l.l0=2*Ys.l.l0;
                    Ms=Ms*2;
                } else
                {
                    Xs.l.l0=MulDiv(Xs.l.l0, 16384, Ms);
                    Ys.l.l0=MulDiv(Ys.l.l0, 16384, Ms);
                    Ms=16384;
                }
                break;
            };
            case '/': {
                if (Ms>=256)
                {
                    Xs.l.l0=Xs.l.l0/2;
                    Ys.l.l0=Ys.l.l0/2;
                    Ms=Ms/2;
                } else
                {
                    Xs.l.l0=Xs.l.l0*128/Ms;
                    Ys.l.l0=Ys.l.l0*128/Ms;
                    Ms=128;
                }
                break;
            };
            case ',': { Dx--; break; };
            case '.': { Dx++; break; };
            case '1': { QFlag=1; break; };
            case '2': { QFlag=2; break; };
            case '3': { QFlag=3; break; };
            case '4': { QFlag=4; break; };
            case 'm': { MFlag=!MFlag; break; };
            case 'M': { MFlag=!MFlag; break; };
            case  0:
            {
                ch=getch();
                switch (ch)
                {
                    case 68: { SaveBmp("SCREEN00.BMP", &Buf); break; } //F10
                    case 71:                                           //Home
                    {
                        As=0;
                        Ms=128;
                        Xs.l.l0=0;
                        Ys.l.l0=0;
                        break;
                    };
                    case 72: { Ys.i.i1--; break; }    //Up
                    case 75: { Xs.i.i1--; break; }    //Left
                    case 77: { Xs.i.i1++; break; }    //Right
                    case 80: { Ys.i.i1++; break; }    //Down
                }
            }
        }
        ch='^';
    }
    if (Mb & 2)
    {
        Xs.i.i1+=Dx;
        Ys.i.i1+=Dy;
    } else
    if (Mb & 1)
    {
        T=Ms;
        Ms+=Dy;
        if (Ms>16384) Ms=16384;
        if (Ms<128) Ms=128;
        Xs.l.l0=MulDiv(Xs.l.l0, Ms, T);
        Ys.l.l0=MulDiv(Ys.l.l0, Ms, T);
    } else
    {
        if (Dx>256) Dx-=256;
        if (Dx<-256) Dx+=256;
        As+=Dx;
        if (As>512) As-=1024;
        if (As<-512) As+=1024;
        if (Dx!=0) Rotate(&Xs, &Ys, (int)Dx);
    }
    DrawInBuffer(Buf.PBitmap.p.p0, Image.PBitmap.p.p0);
    if (MFlag) MagnBuffer(Buf.PBitmap.p.p0);
    BufferToScreen(Buf.PBitmap.p.p0, Step);
    goto Start;
Fin:
    CloseGraph();

    FreeMemForImage(&Buf);
    FreeMemForImage(&Image);

    printf("%s\n", OutStr);
//    sound(100);delay(1000);nosound();delay(1000);

}


